
set(0,'DefaultTextFontName','Times',...
'DefaultTextFontSize',25,...
'DefaultAxesFontName','Times',...
'DefaultAxesFontSize',25,...
'DefaultLineLineWidth',2,...
'DefaultLineMarkerSize',7.75)
disp('done')

gain_float = [1 0];
gain_outflow = [1 0];
gain_reject = [0 1];

t_float= 26000; t_out= 26000; t_reject= 26000; t_in= 26000; t_ppm= 26000; t_Psp = 26000; 
sim('CFU_model_simulink');
x_initial = x_simulink(end,:)';

%% plotting OL (open loop)
x0 = x_initial;
t_float= 16000; t_out= 9000; t_reject= 8000; t_in= 5000; t_ppm= 14000; t_Psp = 20000; 
 sim('CFU_model_simulink');
tout=tout/3600;


%grid on
fig11 = figure(11);
subplot(4,3,7)
plot(tout,Pressure)
grid on
title('\bf{Pressure} $P~(bar)$','Interpreter','latex')
xticks([0 1 2 3 4 5 6 7])
ylim([min(Pressure)-0.05 max(Pressure)+0.05])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);


subplot(4,3,8)
plot(tout,liq_hold_up)
grid on
title('\bf{Liquid hold up} $\alpha_l$','Interpreter','latex')
ylim([min(liq_hold_up)-0.01 max(liq_hold_up)+0.01])
xticks([0 1 2 3 4 5 6 7])
yticks([0.88 0.90 0.92 0.94])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

subplot(4,3,9)
plot(tout,ppm_out)
grid on
title('$ppm_{out}$','Interpreter','latex')
ylim([min(ppm_out)-1 max(ppm_out)+1])
xticks([0 1 2 3 4 5 6 7])
yticks([24 26 28 30])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

subplot(4,3,1)
plot(tout,F_reject)
grid on
title('\bf{Reject flow} $F_{reject}~(m^3/h)$','Interpreter','latex')
% xlabel('t (h)')
xticks([0 1 2 3 4 5 6 7])
yticks([6 7.5 9])
ylim([min(F_reject)-0.3 max(F_reject)+0.3])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

subplot(4,3,2)
plot(tout,F_out)
grid on
title('\bf{Water outflow} $F_{out}~(m^3/h)$','Interpreter','latex')
xticks([0 1 2 3 4 5 6 7])
yticks([69.2 69.6 70 70.4])
ylim([min(F_out)-0.2 max(F_out)+0.2])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);


subplot(4,3,3)
plot(tout,F_flotation)
grid on
title('\bf{Flotation gas flow} $F_{float}~(m^3/h)$','Interpreter','latex')
xticks([0 1 2 3 4 5 6 7])
ylim([min(F_flotation)-0.02 max(F_flotation)+0.02])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);

subplot(4,3,4)
plot(tout,F_in)
grid on
title('\bf{Inflow} $F_{in}~(m^3/h)$','Interpreter','latex')
xlim([0 max(tout)])
ylim([min(F_in)-0.2 max(F_in)+0.2])
yL = get(gca,'YLim');
xticks([0 1 2 3 4 5 6 7])
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);


subplot(4,3,5)
plot(tout,ppm_in_as)
grid on
title('$ppm_{in}^{fs}$','Interpreter','latex')
ylim([min(ppm_in_as)-1 max(ppm_in_as)+1])
xticks([0 1 2 3 4 5 6 7])
yticks([120 124 128])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);


subplot(4,3,6)
plot(tout,ppm_in)
grid on
title('$ppm_{in}$','Interpreter','latex')
ylim([min(ppm_in)-1 max(ppm_in)+1])
xticks([0 1 2 3 4 5 6 7])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);


subplot(4,3,10)
plot(tout,oil_hold_up)
grid on
title('\bf{$~~~~~~~~~$Oil hold up top} $\alpha_{oil}^{top}$','Interpreter','latex')
ylim([min(oil_hold_up)*0.9 max(oil_hold_up)*1.1])
xticks([0 1 2 3 4 5 6 7])
yticks(1e-3*[1.1 1.3 1.5 1.7 1.9 2.1])
xlabel('\it t $(h)$','Interpreter','latex')
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);


subplot(4,3,11)
plot(tout,gas_hold_up)
grid on
title('\bf{Gas hold up top} $\alpha_{gas}^{top}$','Interpreter','latex')
ylim([min(gas_hold_up)*0.9 max(gas_hold_up)*1.1])
xticks([0 1 2 3 4 5 6 7])
yticks([0.6 0.75 0.9])
xlabel('\it t $(h)$','Interpreter','latex')
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);



subplot(4,3,12)
plot(tout,1-gas_hold_up-oil_hold_up)
grid on
title('\bf{Water hold up top} $(1-\alpha_{gas}^{top}-\alpha_{oil}^{top})$','Interpreter','latex')
ylim([0.1 0.4])
xticks([0 1 2 3 4 5 6 7])
yticks([0.1 0.2 0.3 0.4])
xlabel('\it t $(h)$','Interpreter','latex')
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_float/3600  t_float/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

%print('-depsc2','-r600','c6-OL.eps')

% close(fig1)
% change the manual switches to make it automatic control

%% Optimal control

gain_float = [0 1] ;
gain_outflow = [0 1];
gain_reject = [0 1];

x0 = x_initial;
t_Psp = 5000; t_out= 10000; t_reject= 15000;  t_in= 20000; t_ppm= 25000; 
sim('CFU_model_simulink_opt');
tout=tout/3600;

set(0,'DefaultTextFontName','Times',...
'DefaultTextFontSize',25,...
'DefaultAxesFontName','Times',...
'DefaultAxesFontSize',25,...
'DefaultLineLineWidth',2,...
'DefaultLineMarkerSize',7.75)
disp('done')

%grid on
fig14 = figure(14);
subplot(4,3,7)
plot(tout,Pressure)
grid on
title('\bf{Pressure} $P~(bar)$','Interpreter','latex')
xticks([0 1 2 3 4 5 6 7 8])
ylim([min(Pressure)-0.05 max(Pressure)+0.05])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

subplot(4,3,8)
plot(tout,liq_hold_up)
grid on
title('\bf{Liquid hold up} $\alpha_l$','Interpreter','latex')
ylim([min(liq_hold_up)-0.01 max(liq_hold_up)+0.01])
xticks([0 1 2 3 4 5 6 7 8])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

subplot(4,3,9)
plot(tout,ppm_out)
grid on
title('$ppm_{out}$','Interpreter','latex')
ylim([min(ppm_out)-1 max(ppm_out)+1])
xticks([0 1 2 3 4 5 6 7 8])
yticks([19 22 25 28 31])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

subplot(4,3,1)
plot(tout,F_reject)
grid on

title('\bf{Reject flow} $F_{reject}~(m^3/h)$','Interpreter','latex')
xticks([0 1 2 3 4 5 6 7 8])
yticks([6 10 14])
ylim([min(F_reject)-0.3 max(F_reject)+0.3])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);


subplot(4,3,2)
plot(tout,F_out)
grid on

title('\bf{Water outflow} $F_{out}~(m^3/h)$','Interpreter','latex')
xticks([0 1 2 3 4 5 6 7 8])
ylim([min(F_out)-1 max(F_out)+1])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);


subplot(4,3,3)
plot(tout,F_flotation)
grid on
title('\bf{Flotation gas flow} $F_{float}~(m^3/h)$','Interpreter','latex')
xticks([0 1 2 3 4 5 6 7 8])
yticks([2.5 3.5 4.5])
ylim([min(F_flotation)-0.2 max(F_flotation)+0.2])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);



subplot(4,3,4)
plot(tout,F_in)
grid on
title('\bf{Inflow} $F_{in}~(m^3/h)$','Interpreter','latex')
xlim([0 max(tout)])
ylim([min(F_in)-1 max(F_in)+1])
yL = get(gca,'YLim');
xticks([0 1 2 3 4 5 6 7 8])
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);

subplot(4,3,6)
plot(tout,ppm_in)
grid on
title('$ppm_{in}$','Interpreter','latex')
ylim([min(ppm_in)-5 max(ppm_in)+5])
xticks([0 1 2 3 4 5 6 7 8])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);


subplot(4,3,10)
plot(tout,oil_hold_up)
grid on
title('\bf{$~~~~~~~~~$Oil hold up top} $\alpha_{oil}^{top}$','Interpreter','latex')
ylim([min(oil_hold_up)*0.9 max(oil_hold_up)*1.1])
xticks([0 1 2 3 4 5 6 7 8])
yticks([0.8 1.2 1.6 ]*1e-3)
xlabel('\it t $(h)$','Interpreter','latex')
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);


subplot(4,3,11)
plot(tout,gas_hold_up)
grid on
title('\bf{Gas hold up top} $\alpha_{gas}^{top}$','Interpreter','latex')
ylim([min(gas_hold_up)*0.9 max(gas_hold_up)*1.1])
xticks([0 1 2 3 4 5 6 7 8])
yticks([0.4 0.6 0.8 1])
xlabel('\it t $(h)$','Interpreter','latex')
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);

subplot(4,3,5)
plot(tout,ppm_in_as)
grid on
title('$ppm_{in}^{fs}$','Interpreter','latex')
ylim([min(ppm_in_as)-2 max(ppm_in_as)+2])
xticks([0 1 2 3 4 5 6 7])
yticks([120  127.5  135])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);


subplot(4,3,12)
plot(tout,1-gas_hold_up-oil_hold_up)
grid on
title('\bf{Water hold up top} $(1-\alpha_{gas}^{top}-\alpha_{oil}^{top})$','Interpreter','latex')
ylim([0 0.7])
xticks([0 1 2 3 4 5 6 7 8])
yticks([0.1 0.3 0.5 0.7])
xlabel('\it t $(h)$','Interpreter','latex')
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([t_out/3600  t_out/3600],yL,'Color','b','LineStyle','--','LineWidth',1);
line([t_reject/3600  t_reject/3600],yL,'Color','r','LineStyle','--','LineWidth',1);
line([t_in/3600  t_in/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([t_ppm/3600  t_ppm/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([t_Psp/3600  t_Psp/3600],yL,'Color','k','LineStyle','--','LineWidth',1);





%close(fig3) 
%print('-depsc2','-r600','c6-OC.eps')

%%
optopt = x_simulink(1984,:);
optopt = [flipud([optopt(1:10)' optopt(11:20)' optopt(21:30)']); 0 optopt(33) 0]

fig13 = figure(13);
subplot(1,3,2)

plot(flipud(optopt(:,1))*1e10,0:10,'-mo',...
    'LineWidth',4,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[.49 1 .63],...
    'MarkerSize',15)
hold on

title('\bf{Free bubbles} $(\#/m^3)$','Interpreter','latex')
ylim([0 10]); yticks(0:1:10); ylabel('\bf{Control volume number} $i$','Interpreter','latex');
xlim([0 3.5e10])
subplot(1,3,1)
plot(flipud(optopt(:,2))*1e10,0:10,'-mo',...
    'LineWidth',4,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[.49 1 .63],...
    'MarkerSize',15) 
hold on
title('\bf{Droplets} $(\#/m^3)$','Interpreter','latex')
ylim([0 10]); yticks(0:1:10);
xlim([0 13e9])
xticks(1e9*[0 2 4 6 8 10 12])

subplot(1,3,3)
plot(flipud(optopt(:,3))*1e10,0:10,'-mo',...
    'LineWidth',4,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[.49 1 .63],...
    'MarkerSize',15) 
hold on
title('\bf{Loaded bubbles} $(\#/m^3)$','Interpreter','latex')
ylim([0 10]); yticks(0:1:10); xlim([0 2.5e10])
%print('-depsc2','-r600','c6-SSO.eps')
